<?php

ob_start(); // Start output buffering

function downloadMedia($mediaUrl, $contentType) {
    setcookie("downloadStarted", 1, time() + 20);
    // Get the base filename without query parameters
    $parsedUrl = parse_url($mediaUrl);
    $path = $parsedUrl['path'];
    $basename = basename($path);

    // Determine the correct file extension based on the MIME type
    $extensionMap = [
        'image/jpeg' => 'jpg',
        'image/png' => 'png',
        'image/gif' => 'gif',
        'image/webp' => 'webp',
        'image/heic' => 'heic', // High Efficiency Image Format
        'image/bmp' => 'bmp',
        'image/svg+xml' => 'svg', // Scalable Vector Graphics
        'image/tiff' => 'tiff',
        
        'video/mp4' => 'mp4',
        'video/quicktime' => 'mov',
        'video/x-msvideo' => 'avi',
        'video/x-ms-wmv' => 'wmv',
        'video/mpeg' => 'mpeg',
        'video/webm' => 'webm',
        'video/3gpp' => '3gp',
        'video/3gpp2' => '3g2',
        'video/x-matroska' => 'mkv',
        'video/ogg' => 'ogv',
    
        // Audio formats, if needed
        'audio/mpeg' => 'mp3',
        'audio/ogg' => 'ogg',
        'audio/mp4' => 'm4a',
        'audio/x-wav' => 'wav',
        'audio/x-ms-wma' => 'wma',
        'audio/webm' => 'weba',
        'audio/flac' => 'flac',
        'audio/aac' => 'aac',
        'audio/x-aiff' => 'aiff',
    ];
    
    $fileExtension = isset($extensionMap[$contentType]) ? $extensionMap[$contentType] : '';

    // If there's no extension in the basename or it's not one we expect, append the correct one
    if (!preg_match('/\.(jpg|jpeg|png|gif|mp4|mov|avi|wmv|mpeg|webm|3gp|3g2|mkv|ogv|mp3|ogg|m4a|wav|wma|weba|flac|aac|aiff|heic|bmp|svg|tiff)$/', $basename)) {
        $basename .= '.' . $fileExtension;
    }

    // Sanitize the filename to remove any unwanted characters
    $safeFilename = rawurlencode($basename);
    // $safeFilename = preg_replace('/[^a-zA-Z0-9-_\.]/', '', $basename);

    // Set the correct headers to force the file download
    header('Content-Type: ' . $contentType);
    header('Content-Disposition: attachment; filename="' . $safeFilename . '"');

    // Clear any output buffering
    ob_clean();
    flush();

    // Use readfile to output the file for download
    $status = @readfile($mediaUrl);

    // Check if readfile was successful
    if ($status === false) {
        // If readfile failed, log the error or notify
        error_log('Failed to download the file: ' . $mediaUrl);
    }

    exit;
}


function getFileTypeFromHeaders($url) {
    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_NOBODY, 1);
    curl_exec($ch);
    $contentType = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
    curl_close($ch);
    return $contentType; // Return the full MIME type
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    if (isset($_POST['imgOrReelsIgtv']) && !empty(trim($_POST['imgOrReelsIgtv']))) {
        $inputValue = filter_var($_POST['imgOrReelsIgtv'], FILTER_SANITIZE_STRING);

$curl = curl_init();
curl_setopt_array($curl, [
	CURLOPT_URL => "https://facebook-reel-and-video-downloader.p.rapidapi.com/app/main.php?url=" . urlencode($inputValue),
	CURLOPT_RETURNTRANSFER => true,
	CURLOPT_ENCODING => "",
	CURLOPT_MAXREDIRS => 10,
	CURLOPT_TIMEOUT => 30,
	CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
	CURLOPT_CUSTOMREQUEST => "GET",
	CURLOPT_HTTPHEADER => [
		"X-RapidAPI-Host: facebook-reel-and-video-downloader.p.rapidapi.com",
		"X-RapidAPI-Key: 98e3c82106mshd9b883ac6c7a69bp141775jsnd1c78264c142"
	],
]);

$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);

        if ($err) {
            echo "cURL Error: " . htmlspecialchars($err);
        } else {
            $data = json_decode($response, true);
           
            if (isset($data['media'][0]['hd_url'])) {
                $mediaUrl = $data['media'][0]['hd_url'];
                echo '<script>console.log( "  ' . $mediaUrl .' " )</script>';

                $fileType = getFileTypeFromHeaders($mediaUrl); // This should return the full MIME type
            

                // Make sure that you pass the MIME type directly to downloadMedia
                if ($fileType) {
                    downloadMedia($mediaUrl, $fileType);
                } else {
                    echo '<script>alert("Unknown or unsupported file type.")</script>';
                }

            } else {
                echo '<script>alert("Please enter valid link OR Maybe your provided link is restricted by user")</script>'; 
            }
        }
    } else {
        // Input is empty or not set
        echo '<script>alert("The input field is empty. Please enter a URL.");</script>';
    }
}


ob_end_flush(); // Flush the output buffer and send to browser

?>


<?php
include 'includes/header.php';
$page = 'home';
?>

<style>
.banner_section::before {
    background: #0e326c;
}

.banner_section {
    background-image: url(images/facebook.webp);
}
</style>

<main>




    <!-- header section start-->
    <!-- banner section start-->

    <div class="banner_section layout_padding layout_padding343" id="topSection">
        <div class="container">
            <h1 class="best_taital">Explore FaceBook and Download</h1>
            <div class="martop">
                <div class="" id="pills-tab" role="tablist">
                    <div class="row justify-content-center">
                        <div class="col-xl-2 col-lg-2 col-md-2 col-5 icon-div text-center">
                            <button class="tab-tab active" id="pills-profile-tab" data-bs-toggle="pill"
                                data-bs-target="#pills-profile" type="button" role="tab" aria-controls="pills-profile"
                                aria-selected="false" tabindex="-1">
                                <img src="images/video.png" alt="Video Icon" class="img-fluid icon-img">
                                <h5 class="mt-2">Regular Videos</h5>
                            </button>
                        </div>
                        <div class="col-xl-2 col-lg-2 col-md-2 col-5 icon-div text-center">
                            <button class="tab-tab" id="pills-contact1-tab" data-bs-toggle="pill"
                                data-bs-target="#pills-contact1" type="button" role="tab" aria-controls="pills-contact1"
                                aria-selected="false" tabindex="-1">
                                <img src="images/reels.png" alt="Video Icon" class="img-fluid icon-img">
                                <h5 class="mt-2">Short/Reels</h5>
                            </button>
                        </div>
                    </div>
                </div>
            </div>

            <div class="box_main mt-3">

                <form method="POST">
                    <input type="text" class="email_bt" autocomplete="off" placeholder="Paste videos link here..."
                        name="imgOrReelsIgtv" required>
                    <button type="submit" class="subscribe_bt imgOrReelsIgtv" name="imgOrReelsIgtvBtn">Download</button>
                </form>

            </div>

            <div class="tab-content" id="pills-tabContent">
                <div class="tab-pane fade show active" id="pills-home" role="tabpanel" aria-labelledby="pills-home-tab">
                    <p class="there_text">Explore the simplicity of downloading Facebook reels and videos with
                        AllClipDownloader. Our service lets you easily save engaging Facebook content, from captivating
                        reels to informative videos. AllClipDownloader is your solution for quick, reliable, and safe
                        access to your favorite Facebook videos and reels offline</p>
                </div>
            </div>



            <div class="bt_main">
                <div class="discover_bt"><a href="#secSec">Discover More</a>
                    <div class="" id="apeending">

                    </div>
                </div>
            </div>
        </div>
    </div>

    <?php include 'includes/brands.php' ?>

    <?php include 'includes/steps.php' ?>

    <div class="">
        <div class="marketing_section layout_padding" id="secSec">
            <div class="container">
                <div class="row">
                    <div class="col-md-6">
                        <div class="image_1 padding_0"><img src="images/ser3.jpg"></div>
                    </div>
                    <div class="col-md-6">
                        <div class="job_section_2">
                            <h1 class="jobs_text">Youtube</h1>
                            <p class="dummy_text">AllClipDownloader reimagines YouTube video downloading, offering an intuitive platform for effortlessly archiving everything from educational tutorials to engaging vlogs and music videos. Our service caters to all your YouTube content needs, enabling you to create a personal library of high-quality YouTube videos. Experience the ultimate convenience with AllClipDownloader – your gateway to easy, swift, and secure YouTube downloads for an offline viewing experience like no other.</p>
                            <div class="apply_bt"><a href="youtube">Try now</a></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="marketing_section layout_padding">
            <div class="container" id="secSec">
                <div class="row">
                    <div class="col-md-6">
                        <div class="job_section">
                            <h1 class="jobs_text">TikTok Video Download Mastery with AllClipDownloader</h1>
                            <p class="dummy_text">Transform your Facebook video downloading experience with AllClipDownloader. Our platform is expertly crafted to make saving videos and reels from Facebook straightforward and secure. Capture and preserve personal moments or public content with ease. AllClipDownloader is your reliable partner for quick and high-quality Facebook video downloads, ensuring you can relish your favorite Facebook moments offline, whenever desired.</p>
                            <div class="apply_bt"><a href="tiktok">Try now</a></div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="image_1 padding_0"><img src="images/ser2.jpg"></div>
                    </div>
                </div>
            </div>
        </div>

        <div class="marketing_section layout_padding">
            <div class="container">
                <div class="row">
                    <div class="col-md-6">
                        <div class="image_1 padding_0"><img src="images/three.gif"></div>
                    </div>
                    <div class="col-md-6">
                        <div class="job_section_2">
                            <h1 class="jobs_text">Instagram Content Downloading Excellence via AllClipDownloader</h1>
                            <p class="dummy_text">Elevate your Instagram experience with AllClipDownloader’s specialized tool for downloading Instagram videos, photos, and reels. Tailored for Instagram lovers, our platform simplifies the process of saving cherished Instagram memories, be it stunning reels, photos, or videos. Whether it’s for personal archiving or creating an inspirational content collection, AllClipDownloader guarantees a smooth, secure, and user-friendly downloading journey. Dive into the world of high-quality Instagram downloads and access your beloved content offline, at any time.</p>
                            <div class="apply_bt"><a href="https://allclipdownloader.com/">Try now</a></div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <?php include 'includes/faq.php' ?>


</main>

<?php
include 'includes/footer.php';
$page = 'home';
?>